function K0_1 = compute_K0_1(K_First, N, h, k)
 Epsilon=1e-6;
    % AEI STEP 2: Compute parameter mu
    mu = zeros((N + 2), N + 2);
    for ii = 1:N + 2
        mu(ii, 1) = 1 / Epsilon;
        mu(ii, N + 2) = 1 / Epsilon;
        mu(1, ii) = 1 / Epsilon;
        mu(N + 2, ii) = 1 / Epsilon;
    end

    for i = 2:N + 1
        for j = 2:N + 1
            mu(i, j) = 1 / sqrt(((K_First(i + 1, j) - K_First(i - 1, j)) / (2 * h))^2 + ...
                                 ((K_First(i, j + 1) - K_First(i, j - 1)) / (2 * h))^2 + Epsilon^2);
        end
    end

    % AEI STEP 4: Obtain new K_0
    % Initialize diagonals
    os1 = zeros((N + 2) * (N + 1), 1);  % diagonal((N+2)*(N+1),+(N+2))
    os2 = zeros((N + 2)^2 - 1, 1);      % diagonal((N+2)^2-1,+1))
    os3 = ones((N + 2)^2, 1);           % main diagonal
    os4 = zeros((N + 2)^2 - 1, 1);      % diagonal((N+2)^2-1,-1))
    os5 = zeros((N + 2) * (N + 1), 1);  % diagonal((N+2)*(N+1),-(N+2))

    for ii = 2:N + 1
        for j = 2:N + 1
            os1((N + 2) * (ii - 1) + j) = -(1 / (2 * h^2)) * (mu(ii + 1, j) + mu(ii, j));
            os2((N + 2) * (ii - 1) + j) = -(1 / (2 * h^2)) * (mu(ii, j + 1) + mu(ii, j));
            os3((N + 2) * (ii - 1) + j) = (1 / (2 * h^2)) * (mu(ii + 1, j) + mu(ii - 1, j) + ...
                                   mu(ii, j + 1) + mu(ii, j - 1) + 4 * mu(ii, j));
            os4((N + 2) * (ii - 1) + (j - 1)) = -(1 / (2 * h^2)) * (mu(ii, j - 1) + mu(ii, j));
            os5((N + 2) * (ii - 2) + j) = -(1 / (2 * h^2)) * (mu(ii + 1, j) + mu(ii, j));
        end
    end

    % Construct diagonals for sparse matrix A_0
    oS1 = [zeros(N + 2, 1); os1];  % diagonal((N+2)*(N+1),+(N+2))
    oS2 = [0; os2];                % diagonal((N+2)^2-1,+1))
    oS3 = [os4; 0];                % diagonal((N+2)^2-1,-1))
    oS4 = [os5; zeros(N + 2, 1)];  % diagonal((N+2)*(N+1),-(N+2))

    % Sparse matrix A_0
    A_0 = spdiags([oS4, oS3, os3, oS2, oS1], [-(N + 2), -1, 0, 1, (N + 2)], (N + 2)^2, (N + 2)^2);

    % Finding vector b_0
    b_0 = zeros((N + 2)^2, 1);
    for j = 1:N + 3
        b_0(j) = k;
    end
    for j = (N + 2) * (N + 1):(N + 2)^2
        b_0(j) = k;
    end
    for ii = 1:N - 1
        for j = 1:2
            b_0((N + 2) * (ii + 1) + (j - 1)) = k;
        end
    end

    % Finding Background K0 next
    K0_1 = A_0 \ b_0;
end
