function Phi_2 = compute_eigenfunctions_AEI(K_First, N, h, M)
Epsilon=1e-6;
    % AEI STEP 2: Compute parameter mu
    mu = zeros((N + 2), N + 2);
    for ii = 1:N + 2
        mu(ii, 1) = 1 / Epsilon;
        mu(ii, N + 2) = 1 / Epsilon;
        mu(1, ii) = 1 / Epsilon;
        mu(N + 2, ii) = 1 / Epsilon;
    end

    for i = 2:N + 1
        for j = 2:N + 1
            mu(i, j) = 1 / sqrt(((K_First(i + 1, j) - K_First(i - 1, j)) / (2 * h))^2 + ...
                                 ((K_First(i, j + 1) - K_First(i, j - 1)) / (2 * h))^2 + Epsilon^2);
        end
    end
    % Initialize main diagonal
    or1 = ones(N^2, 1);  % main diagonal
    for ii = 2:N+1
        for j = 2:N+1
            or1((N)*(ii-2) + (j-1)) = (1 / (2 * h^2)) * ...
                (mu(ii+1, j) + mu(ii-1, j) + mu(ii, j+1) + mu(ii, j-1) + 4 * mu(ii, j));
        end
    end

    % Initialize diagonal (N^2-1, +-1)
    or2 = zeros(N^2 - 1, 1);
    for ii = 2:N+1
        for j = 2:N
            or2((N)*(ii-2) + (j-1)) = -(1 / (2 * h^2)) * (mu(ii, j+1) + mu(ii, j));
        end
    end

    % Initialize diagonal (N^2-N, +-N)
    or3 = zeros(N^2 - N, 1);
    for ii = 2:N
        for j = 2:N+1
            or3((N)*(ii-2) + (j-1)) = -(1 / (2 * h^2)) * (mu(ii, j) + mu(ii+1, j));
        end
    end

    % Construct diagonals for sparse matrix A2_eig
    oR1 = [zeros(N, 1); or3];  % diagonal(N^2-N,+N)
    oR2 = [or3; zeros(N, 1)];  % diagonal(N^2-N,-N)
    oR3 = [0; or2];            % diagonal(N^2-1,+1)
    oR4 = [or2; 0];            % diagonal(N^2-1,-1)

    % Sparse matrix A2_eig
    A2_eig = spdiags([oR2, oR4, or1, oR3, oR1], [-N, -1, 0, 1, N], N^2, N^2);

    % Finding eigenfunctions matrix
    [eignF2, ~] = eigs(A2_eig, M, 'smallestabs');

    % Initialize V2 and set boundary conditions
    V2 = ones(N^2 + 2 * N - 2, M);
    for ii = 1:N-1
        V2((N+2)*ii - 1, :) = 0;
        V2((N+2)*ii, :) = 0;
    end

    % Fill V2 with eigenfunctions
    for j = 0:N-1
        for ii = 1:N
            V2((N+2)*j + ii, :) = eignF2(N*j + ii, :);
        end
    end

    % Construct Phi_2
    Phi_2 = [zeros(N+3, M); V2; zeros(N+3, M)];
end
