function H = construct_H(K, N, h, k)
    % Coefficient for forward problem
  a = -1 / (h^2);
  c = complex(3 / (h^2) - k^2, k / h);
  d = complex(2 / (h^2) - k^2, sqrt(2) * (k / h));
   

    % Calculate b matrix based on K
    b = zeros(N, N);
    for i = 1:N
        for j = 1:N
            b(i, j) = -(K(i+1, j+1)).^2 + (4 / (h^2));
        end
    end

  

    %% Matrix Construction for H
    off1 = ones((N+2)^2-1, 1);
    for j = 1:N+1
        off1(j * (N+2), 1) = 0;
    end
    ohh1 = [0; off1];

    off2 = ones((N+2)^2-1, 1);
    for j = 1:N+1
        off2(j * (N+2), 1) = 0;
    end
    ohh2 = [off2; 0];

    off3 = ones((N+2) * (N+1), 1);
    ohh3 = [zeros(N+2, 1); off3];

    off4 = ones((N+2) * (N+1), 1);
    ohh4 = [off4; zeros(N+2, 1)];

    off5 = ones((N+2)^2, 1);
    off5(1) = d;
    off5(N+2) = d;
    off5((N+1) * (N+2) + 1) = d;
    off5((N+2)^2) = d;

    for j = 2:N+1
        off5(j) = c;
    end
    for j = (N+2)^2-N:(N+2)^2-1
        off5(j) = c;
    end
    off5(N+3) = c;
    off5((N+1) * (N+2)) = c;

    for j = 0:N-2
        off5((N+2) * (j+2)) = c;
        off5((N+2) * (j+2) + 1) = c;
    end
    for j = 1:N
        for ii = 2:N+1
            off5((N+2) * j + ii) = b(ii-1, j);
        end
    end

    % Construct the sparse matrix H
    H = spdiags([a .* ohh4, a .* ohh2, off5, a .* ohh1, a .* ohh3], ...
                [-(N+2), -1, 0, 1, N+2], (N+2)^2, (N+2)^2);
end
