function dH_dk = construct_dH_dk(K, N)
% Input Parameters
% Wave number
k = 30;
lambda = 2 * pi / k;
h = lambda / 10;
% Coefficient for inverse problem
c1=complex(-2*k,1/h);
d1=complex(-2*k,sqrt(2)/h);
    % Initialize b1_dH matrix
    b1_dH = zeros(N, N);
    
    % Compute the elements of b1_dH
    for ii = 1:N
        for j = 1:N
            b1_dH(ii, j) = -2 * (K(ii + 1, j + 1));
        end
    end

    % Initialize of1 vector
    of1 = ones((N + 2)^2, 1);
    of1(1) = d1;
    of1(N + 2) = d1;
    of1((N + 1) * (N + 2) + 1) = d1;
    of1((N + 2)^2) = d1;

    % Set boundary values in of1
    for j = 2:N+1
        of1(j) = c1;
    end
    for j = (N + 2)^2 - N:(N + 2)^2 - 1
        of1(j) = c1;
    end
    of1(N + 3) = c1;
    of1((N + 1) * (N + 2)) = c1;

    % Modify interior elements based on b1_dH
    for j = 0:N-2
        of1((N + 2) * (j + 2)) = c1;
        of1((N + 2) * (j + 2) + 1) = c1;
    end
    for j = 1:N
        for ii = 2:N+1
            of1((N + 2) * j + ii) = b1_dH(ii - 1, j);
        end
    end

    % Construct the sparse matrix dH_dk_1
    dH_dk = spdiags([of1], [0], (N + 2)^2, (N + 2)^2);
end
