function Phi_1 = first_eigenfunctions(a, N, M, mX)
    % Define auxiliary vectors for sparse matrix creation
    ogg1 = ones((N)^2 - 1, 1);
    for ii = 1:N-1
        ogg1(N * ii) = 0;
    end
    oqq1 = [ogg1; 0];
    oqq2 = [0; ogg1];

    ogg2 = ones(N * (N-1), 1);
    oqq3 = [ogg2; zeros(N, 1)];
    oqq4 = [zeros(N, 1); ogg2];

    ogg3 = ones((N)^2, 1);

    % Construct sparse matrix A1_eig
    A1_eig = spdiags([a .* oqq3, a .* oqq1, -4 * a .* ogg3, a .* oqq2, a .* oqq4], ...
                     [-N, -1, 0, 1, N], N^2, N^2);

    % Compute eigenvalues and eigenfunctions
    [eignF1, ~] = eigs(A1_eig, M, 'smallestabs');

    % Construct the eigenfunction matrix V1
    V1 = ones(N^2 + 2 * N - 2, M);
    for ii = 1:N-1
        V1((N+2) * ii - 1, :) = 0;
        V1((N+2) * ii, :) = 0;
    end

    % Fill the eigenfunction matrix
    for j = 0:N-1
        for ii = 1:N
            V1((N+2) * j + ii, :) = eignF1(N * j + ii, :);
        end
    end

    % Add zeros to the boundaries of the eigenfunction matrix
    Phi_1 = [zeros(N+3, M); V1; zeros(N+3, M)];

 
end
