function p = random_projection(N)
    % Number of elements in the reshaped solution
    r = (N + 2)^2 - 1;

    % Random sample from the elements of the reshaped matrix
    D = randsample(1:(N + 2)^2, r);

    % Define s as half of r, rounded down
    s = floor(0.5 * r);

    % Randomly select s elements
    n = randsample(D, s);

    % Initialize q vector (logical vector for efficiency)
    q = false(1, (N + 2)^2);

    % Set the selected positions in q to true
    q(n) = true;

    % Initialize projection matrix p as an identity matrix
    p = eye(r, (N + 2)^2);

    % Modify p based on q (set certain diagonal entries to 0)
    for i = 1:r
        if ~q(i)  % If q(i) is false, set the diagonal entry to 0
            p(i, i) = 0;
        end
    end
end
